HDU 5389 Zero Escape (类0/1背包)

Zero Escape

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)

Total Submission(s): 883    Accepted Submission(s): 452

Problem Description

Zero Escape, is a visual novel adventure video game directed by Kotaro Uchikoshi (you may hear about ever17?) and developed by Chunsoft.

Stilwell is enjoying the first chapter of this series, and in this chapter digital root is an important factor.

This is the definition of digital root on Wikipedia:

The digital root of a non-negative integer is the single digit value obtained by an iterative process of summing digits, on each iteration using the result from the previous iteration to compute a digit sum. The process continues until a single-digit number
is reached.

For example, the digital root of 65536
is 7,
because 6+5+5+3+6=25
and 2+5=7.

In the game, every player has a special identifier. Maybe two players have the same identifier, but they are different players. If a group of players want to get into a door numbered
X(1≤X≤9),
the digital root of their identifier sum must be X.

For example, players {1,2,6}
can get into the door 9,
but players {2,3,3}
can‘t.

There is two doors, numbered A
and B.
Maybe A=B,
but they are two different door.

And there is n
players, everyone must get into one of these two doors. Some players will get into the door
A,
and others will get into the door B.

For example:

players are {1,2,6},
A=9,
B=1

There is only one way to distribute the players: all players get into the door
9.
Because there is no player to get into the door 1,
the digital root limit of this door will be ignored.

Given the identifier of every player, please calculate how many kinds of methods are there,
mod 258280327.

Input

The first line of the input contains a single number
T,
the number of test cases.

For each test case, the first line contains three integers
n,
A
and B.

Next line contains n
integers idi,
describing the identifier of every player.

T≤100,
n≤105,
∑n≤106,
1≤A,B,idi≤9

Output

For each test case, output a single integer in a single line, the number of ways that these
n
players can get into these two doors.

Sample Input

4
3 9 1
1 2 6
3 9 1
2 3 3
5 2 3
1 1 1 1 1
9 9 9
1 2 3 4 5 6 7 8 9

Sample Output

1
0
10
60

Source

2015 Multi-University Training Contest 8

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5389

题目大意:一群人每人有个号idi,两个门A B分别有个值,现在要把这群人分成两组(可以有一组为空)进入两个门,要求每组id和的数字根与门的值相同

题目分析:数字根直接mod 9就行了,随然公式是(x - 1) % 9 + 1,但是这里只要对不同的作区分即可,先判断(sum % 9)是不是不等于(A + B) % 9,如果是,则显然只可能把人全放到一个门里,这时候有三种情况,一个门都不行;只能进一个门;和两个门值相同,两个门都可以进,特判完,可以进行dp,dp[i][j]表示前i个人中进A门,数字根为j的可能数,这里不用管B,因为一共就两门,不是进A就是进B,dp[i][(j + a[i]) % 9] = dp[i][(j + a[i]) % 9] +
dp[i - 1][j],即放或者不放,最后答案为dp[n][A % 9]

#include <cstdio>
#include <cstring>
#define ll long long
using namespace std;
int const MOD = 258280327;
int const MAX = 100005;
int a[MAX], dp[MAX][11];

int main()
{
    int T;
    scanf("%d", &T);
    while(T --)
    {
        int n, A, B;
        memset(dp, 0, sizeof(dp));
        dp[0][0] = 1;
        int sum = 0;
        scanf("%d %d %d", &n, &A ,&B);
        for(int i = 1; i <= n; i++)
        {
            scanf("%d", &a[i]);
            sum += a[i];
        }
        if(sum % 9 != (A + B) % 9)
        {
            if(sum % 9 != A % 9 && sum % 9 != B % 9)
                printf("0\n");
            else
                printf("%d\n", A == B ? 2 : 1);
        }
        else
        {
            for(int i = 1; i <= n; i++)
            {
                for(int j = 0; j < 9; j++)
                    dp[i][j] = (dp[i][j] % MOD + dp[i - 1][j] % MOD) % MOD;
                for(int j = 0; j < 9; j++)
                    dp[i][(j + a[i]) % 9] = (dp[i][(j + a[i]) % 9] % MOD + dp[i - 1][j] % MOD) % MOD;
            }
            printf("%d\n", dp[n][A % 9]);
        }
    }
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-12-12 23:58:48

HDU 5389 Zero Escape (类0/1背包)的相关文章

hdu(5389)——Zero Escape(01背包变形)

啊,这是一道挺不错的动态规划的题目呢. 一开始我们并没有找出规律,后来队友突然喊了一句:"dp啊!" 顿时人生豁然开朗了... 于是她很神奇的推出了转移方程,然后再共同查错下,a出了这道题,真是佩服这人的高智商啊 题意: 首先n,代表的是n个人,然后是A,B,分别代表两个门的值. 然后第二行给出了n个人的价值,问你要使这n个人全部进入门中(可以是A,B,或是其中的一扇门),总共有几种方法. 但是要注意这里的价值并不是仅仅加起来就好了,这里是要把它加起来直到为一个个位数. 思路: 定义:

HDU 5389 Zero Escape(dp啊 多校啊 )

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5389 Problem Description Zero Escape, is a visual novel adventure video game directed by Kotaro Uchikoshi (you may hear about ever17?) and developed by Chunsoft. Stilwell is enjoying the first chapter of

HDU 5389 Zero Escape(dp啊 多校)

题目链接:http://acm.hdu.edu.cn/showproblem.php? pid=5389 Problem Description Zero Escape, is a visual novel adventure video game directed by Kotaro Uchikoshi (you may hear about ever17?) and developed by Chunsoft. Stilwell is enjoying the first chapter o

HDU 5389 Zero Escape(dp解法)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5389 题面: Zero Escape Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Total Submission(s): 164    Accepted Submission(s): 73 Problem Description Zero Escape, is a vis

hdu 5389 Zero Escape (dp)

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5389 题意:定义数根:①把每一位上的数字加起来得到一个新的数,②重复①直到得到的数只有1位.给定n,A,B和n个一位数,求把这n个数分成两部分,使得这两部分的其中一部分的和的数根等于A另外一部分的和的数根等于B的方案数. 分析:一个数a的数根s=(a-1)%9+1,为了方便直接用s=a%9,其中0代表9.定义dp[i][j]表示前i个数中数根为j的方案数.对于第i个数可以选也可以不选,那么状态转移方程为

hdu 5389 Zero Escape

传送门 Zero Escape Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 1460    Accepted Submission(s): 716 Problem Description Zero Escape, is a visual novel adventure video game directed by Kotaro U

hdu 2191 悼念512同胞(0 1背包)

Input 输入数据首先包含一个正整数C,表示有C组测试用例,每组测试用例的第一行是两个整数n和m(1<=n<=100, 1<=m<=100),分别表示经费的金额和大米的种类,然后是m行数据,每行包含3个数p,h和c(1<=p<=20,1<=h<=200,1<=c<=20),分别表示每袋的价格.每袋的重量以及对应种类大米的袋数. Output 对于每组测试数据,请输出能够购买大米的最多重量,你可以假设经费买不光所有的大米,并且经费你可以不用完.每

HDU 5389 Zero Escape(DP + 滚动数组)

Zero Escape Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Total Submission(s): 864    Accepted Submission(s): 438 Problem Description Zero Escape, is a visual novel adventure video game directed by Kotaro Uchik

HDU 5389 Zero Escape (MUT#8 dp优化)

[题目链接]:click here~~ [题目大意]: 题意: 给出n个人的id,有两个门,每个门有一个标号,我们记作a和b,现在我们要将n个人分成两组,进入两个门中,使得两部分人的标号的和(迭代的求,直至变成一位数,我们姑且叫做求"和"操作~)分别等于a和b,问有多少种分法. [思路]:比赛的时候还是学弟递推的方程,当时是dp三维dp[i][j]k]:分别表示枚举到第i位,A门,B门的状态,但是一直没想到怎么进一步优化,卡在100n的复杂度了 赛后看了一下题解,(虽然高中生写的题解看